'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _wrapDisplayName = require('recompose/wrapDisplayName');

var _wrapDisplayName2 = _interopRequireDefault(_wrapDisplayName);

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var withinViewport = function withinViewport() {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var _ref$transform = _ref.transform;
  var transform = _ref$transform === undefined ? function (inViewport) {
    return { inViewport: inViewport };
  } : _ref$transform;
  var _ref$containerStyle = _ref.containerStyle;
  var containerStyle = _ref$containerStyle === undefined ? {
    width: '100%',
    height: '100%',
    padding: 0,
    border: 0
  } : _ref$containerStyle;
  var _ref$getHeight = _ref.getHeight;
  var getHeight = _ref$getHeight === undefined ? function (elem) {
    return elem.getBoundingClientRect().height;
  } : _ref$getHeight;
  var _ref$getWidth = _ref.getWidth;
  var getWidth = _ref$getWidth === undefined ? function (elem) {
    return elem.getBoundingClientRect().width;
  } : _ref$getWidth;
  var _ref$getTop = _ref.getTop;
  var getTop = _ref$getTop === undefined ? function (elem) {
    return elem.getBoundingClientRect().top;
  } : _ref$getTop;
  var _ref$getLeft = _ref.getLeft;
  var getLeft = _ref$getLeft === undefined ? function (elem) {
    return elem.getBoundingClientRect().left;
  } : _ref$getLeft;
  var _ref$getViewportHeigh = _ref.getViewportHeight;
  var getViewportHeight = _ref$getViewportHeigh === undefined ? function (_window, _document) {
    return _window.innerHeight || _document.clientHeight;
  } : _ref$getViewportHeigh;
  var _ref$getViewportWidth = _ref.getViewportWidth;
  var getViewportWidth = _ref$getViewportWidth === undefined ? function (_window, _document) {
    return _window.innerWidth || _document.clientWidth;
  } : _ref$getViewportWidth;
  var _ref$defaultAnswer = _ref.defaultAnswer;
  var defaultAnswer = _ref$defaultAnswer === undefined ? true : _ref$defaultAnswer;
  var _ref$wait = _ref.wait;
  var wait = _ref$wait === undefined ? 200 : _ref$wait;
  return function (BaseComponent) {
    var _class, _temp2;

    return _temp2 = _class = function (_Component) {
      _inherits(_class, _Component);

      function _class() {
        var _Object$getPrototypeO;

        var _temp, _this, _ret;

        _classCallCheck(this, _class);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(_class)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.state = {
          containerWidth: null,
          containerHeight: null,
          containerTopOffset: null,
          containerLeftOffset: null,
          windowWidth: null,
          windowHeight: null,
          updated: false
        }, _this.updateState = function () {
          var update = function update() {
            var elem = _this.refs.withinViewportContainer;

            _this.setState({
              containerWidth: getWidth(elem),
              containerHeight: getHeight(elem),
              containerTopOffset: getTop(elem),
              containerLeftOffset: getLeft(elem),
              windowWidth: getViewportWidth(window, document),
              windowHeight: getViewportHeight(window, document),
              updated: true
            });
          };

          if (window.requestAnimationFrame) {
            window.requestAnimationFrame(function () {
              return update();
            });
          } else {
            update();
          }
        }, _this.inViewport = function () {
          if (_this.state.updated) {
            return (_this.state.containerTopOffset < 0 && _this.state.containerHeight + _this.state.containerTopOffset > 0 || _this.state.containerTopOffset >= 0 && _this.state.containerTopOffset < _this.state.windowHeight) && (_this.state.containerLeftOffset < 0 && _this.state.containerWidth + _this.state.containerLeftOffset > 0 || _this.state.containerLeftOffset >= 0 && _this.state.containerLeftOffset < _this.state.windowWidth);
          }
          return defaultAnswer;
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(_class, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          if (window && window.addEventListener) {
            this.debouncedUpdate = (0, _lodash2.default)(this.updateState, wait);
            window.addEventListener('resize', this.debouncedUpdate);
            window.addEventListener('scroll', this.debouncedUpdate);
            this.updateState();
          }
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          if (window && window.removeEventListener) {
            window.removeEventListener('resize', this.debouncedUpdate);
            window.removeEventListener('scroll', this.debouncedUpdate);
          }
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(
            'div',
            {
              ref: 'withinViewportContainer',
              style: containerStyle
            },
            _react2.default.createElement(BaseComponent, _extends({}, transform(this.inViewport()), this.props))
          );
        }
      }]);

      return _class;
    }(_react.Component), _class.displayName = (0, _wrapDisplayName2.default)(BaseComponent, 'withinViewport'), _temp2;
  };
};

exports.default = withinViewport;